import { ɵɵelementStart, ɵɵelement, ɵɵelementEnd, ɵɵnextContext, ɵɵadvance, ɵɵproperty, ɵɵtext, ɵɵtextInterpolate1, ɵɵpipe, ɵɵtextInterpolate, ɵɵpipeBind1, EventEmitter, ɵɵdirectiveInject, ɵɵdefineComponent, ɵɵstaticViewQuery, ɵɵqueryRefresh, ɵɵloadQuery, ɵɵclassMap, ɵɵlistener, ɵɵtemplate, ɵɵstyleProp, ɵɵclassProp, ɵsetClassMetadata, Component, ChangeDetectionStrategy, Input, Output, HostBinding, ViewChild, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule } from '@angular/core';
import { NgIf, CommonModule } from '@angular/common';
import { ShareService, ShareDirective, ShareCountPipe, SHARE_BUTTONS_CONFIG, ShareModule } from '@ngx-share/core';
import { FaIconComponent, FontAwesomeModule } from '@fortawesome/angular-fontawesome';

function ShareButton_div_3_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 6);
    ɵɵelement(1, "fa-icon", 7);
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r3 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("icon", ctx_r3.icon || ctx_r3.ref.shareButton.icon)("fixedWidth", true);
} }
function ShareButton_div_4_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 8);
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r4 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵtextInterpolate1(" ", ctx_r4.text || ctx_r4.ref.shareButton.text, " ");
} }
function ShareButton_div_5_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 9);
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵpipe(3, "shareCount");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r5 = ɵɵnextContext();
    ɵɵadvance(2);
    ɵɵtextInterpolate(ɵɵpipeBind1(3, 1, ctx_r5.shareCount));
} }
var ShareButton = /** @class */ (function () {
    function ShareButton(_share) {
        this._share = _share;
        /** Show button icon */
        this.showIcon = true;
        /** Show button text */
        this.showText = false;
        /** Show sharing count */
        this.showCount = false;
        /** Button size */
        this.size = this._share.config.size;
        /** Button theme */
        this.theme = this._share.config.theme;
        /** Stream that emits when share count is fetched */
        this.count = new EventEmitter();
        /** Stream that emits when share dialog is opened */
        this.opened = new EventEmitter();
        /** Stream that emits when share dialog is closed */
        this.closed = new EventEmitter();
    }
    Object.defineProperty(ShareButton.prototype, "createButton", {
        set: function (button) {
            this.shareCount = 0;
            this.button = button;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShareButton.prototype, "setUrl", {
        /** Set the sharing link */
        set: function (url) {
            this.shareCount = 0;
            this.url = url;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShareButton.prototype, "buttonClass", {
        /** Set theme as button class */
        get: function () {
            return "sb-button sb-" + this.theme;
        },
        enumerable: true,
        configurable: true
    });
    ShareButton.prototype.onCount = function (count) {
        this.shareCount = count;
        this.count.emit(count);
    };
    ShareButton.ɵfac = function ShareButton_Factory(t) { return new (t || ShareButton)(ɵɵdirectiveInject(ShareService)); };
    ShareButton.ɵcmp = ɵɵdefineComponent({ type: ShareButton, selectors: [["share-button"]], viewQuery: function ShareButton_Query(rf, ctx) { if (rf & 1) {
            ɵɵstaticViewQuery(ShareDirective, true);
        } if (rf & 2) {
            var _t;
            ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.ref = _t.first);
        } }, hostVars: 2, hostBindings: function ShareButton_HostBindings(rf, ctx) { if (rf & 2) {
            ɵɵclassMap(ctx.buttonClass);
        } }, inputs: { createButton: ["button", "createButton"], setUrl: ["url", "setUrl"], title: "title", description: "description", image: "image", tags: "tags", autoSetMeta: "autoSetMeta", showIcon: "showIcon", showText: "showText", showCount: "showCount", text: "text", icon: "icon", size: "size", theme: "theme" }, outputs: { count: "count", opened: "opened", closed: "closed" }, decls: 6, vars: 19, consts: [[1, "sb-wrapper", 3, "shareButton", "url", "image", "title", "description", "tags", "autoSetMeta", "getCount", "count", "opened", "closed"], [1, "sb-inner"], [1, "sb-content"], ["class", "sb-icon", 4, "ngIf"], ["class", "sb-text", 4, "ngIf"], ["class", "sb-count", 4, "ngIf"], [1, "sb-icon"], [3, "icon", "fixedWidth"], [1, "sb-text"], [1, "sb-count"]], template: function ShareButton_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "button", 0);
            ɵɵlistener("count", function ShareButton_Template_button_count_0_listener($event) { return ctx.onCount($event); })("opened", function ShareButton_Template_button_opened_0_listener($event) { return ctx.opened.emit($event); })("closed", function ShareButton_Template_button_closed_0_listener($event) { return ctx.closed.emit($event); });
            ɵɵelementStart(1, "div", 1);
            ɵɵelementStart(2, "div", 2);
            ɵɵtemplate(3, ShareButton_div_3_Template, 2, 2, "div", 3);
            ɵɵtemplate(4, ShareButton_div_4_Template, 2, 1, "div", 4);
            ɵɵelementEnd();
            ɵɵtemplate(5, ShareButton_div_5_Template, 4, 3, "div", 5);
            ɵɵelementEnd();
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵstyleProp("font-size", (1 + ctx.size / 20) * 14, "px");
            ɵɵclassProp("sb-show-icon", ctx.showIcon)("sb-show-text", ctx.showText)("sb-show-count", ctx.showCount && ctx.shareCount);
            ɵɵproperty("shareButton", ctx.button)("url", ctx.url)("image", ctx.image)("title", ctx.title)("description", ctx.description)("tags", ctx.tags)("autoSetMeta", ctx.autoSetMeta)("getCount", ctx.showCount);
            ɵɵadvance(3);
            ɵɵproperty("ngIf", ctx.showIcon && ctx.ref.shareButton);
            ɵɵadvance(1);
            ɵɵproperty("ngIf", ctx.showText && ctx.ref.shareButton);
            ɵɵadvance(1);
            ɵɵproperty("ngIf", ctx.showCount && ctx.shareCount);
        } }, directives: [ShareDirective, NgIf, FaIconComponent], pipes: [ShareCountPipe], styles: [".sb-button,   .sb-group{display:inline-flex;align-items:flex-start}  .sb-group{flex-wrap:wrap}  .sb-button{margin:.3125em}  .sb-wrapper{font-size:inherit;cursor:pointer;position:relative;outline:0;min-width:4.125em;height:2.5em;border:none;border-radius:1px;padding:0;line-height:2.571em;background-color:transparent}  .sb-wrapper .sb-count,   .sb-wrapper .sb-icon,   .sb-wrapper .sb-text{display:flex;align-items:center;justify-content:center;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}  .sb-wrapper .sb-inner{display:flex;flex:1;width:100%;height:100%}  .sb-wrapper .sb-content{display:flex;height:100%;width:100%}  .sb-wrapper .sb-text{padding:0 .7em;flex:1;height:100%;white-space:nowrap}  .sb-wrapper .sb-icon{text-align:center;width:100%;height:100%;font-size:1.2em;min-width:2em}  .sb-wrapper .sb-count{font-size:.9em;padding:0 .7em}  .sb-wrapper .sb-count,   .sb-wrapper .sb-text{font-weight:700}  .sb-show-text .sb-icon{width:2em}  .sb-show-count{min-width:5.333em}"], changeDetection: 0 });
    return ShareButton;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ShareButton, [{
        type: Component,
        args: [{
                selector: "share-button",
                templateUrl: "./share-button.html",
                styleUrls: ["./share-button.scss"],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: ShareService }]; }, { createButton: [{
            type: Input,
            args: ["button"]
        }], setUrl: [{
            type: Input,
            args: ["url"]
        }], title: [{
            type: Input
        }], description: [{
            type: Input
        }], image: [{
            type: Input
        }], tags: [{
            type: Input
        }], autoSetMeta: [{
            type: Input
        }], showIcon: [{
            type: Input
        }], showText: [{
            type: Input
        }], showCount: [{
            type: Input
        }], text: [{
            type: Input
        }], icon: [{
            type: Input
        }], size: [{
            type: Input
        }], theme: [{
            type: Input
        }], count: [{
            type: Output
        }], opened: [{
            type: Output
        }], closed: [{
            type: Output
        }], buttonClass: [{
            type: HostBinding,
            args: ["class"]
        }], ref: [{
            type: ViewChild,
            args: [ShareDirective, { static: true }]
        }] }); })();

var ShareButtonModule = /** @class */ (function () {
    function ShareButtonModule() {
    }
    ShareButtonModule.withConfig = function (config) {
        return {
            ngModule: ShareButtonModule,
            providers: [{ provide: SHARE_BUTTONS_CONFIG, useValue: config }]
        };
    };
    ShareButtonModule.ɵmod = ɵɵdefineNgModule({ type: ShareButtonModule });
    ShareButtonModule.ɵinj = ɵɵdefineInjector({ factory: function ShareButtonModule_Factory(t) { return new (t || ShareButtonModule)(); }, imports: [[
                ShareModule,
                FontAwesomeModule,
                CommonModule
            ],
            ShareModule,
            FontAwesomeModule] });
    return ShareButtonModule;
}());
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(ShareButtonModule, { declarations: [ShareButton], imports: [ShareModule,
        FontAwesomeModule,
        CommonModule], exports: [ShareModule,
        FontAwesomeModule,
        ShareButton] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(ShareButtonModule, [{
        type: NgModule,
        args: [{
                declarations: [
                    ShareButton
                ],
                imports: [
                    ShareModule,
                    FontAwesomeModule,
                    CommonModule
                ],
                exports: [
                    ShareModule,
                    FontAwesomeModule,
                    ShareButton
                ]
            }]
    }], null, null); })();

/**
 * Generated bundle index. Do not edit.
 */

export { ShareButton, ShareButtonModule };
//# sourceMappingURL=ngx-share-button.js.map
