import { EventEmitter, ɵɵdirectiveInject, ElementRef, ɵɵdefineComponent, ɵɵelementStart, ɵɵlistener, ɵɵelement, ɵɵelementEnd, ɵɵstyleProp, ɵɵadvance, ɵɵproperty, ɵsetClassMetadata, Component, ChangeDetectionStrategy, Input, Output, ɵɵgetCurrentView, ɵɵrestoreView, ɵɵnextContext, ɵɵtemplate, ɵɵclassMapInterpolate1, ɵɵpipe, ɵɵpipeBind1, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule } from '@angular/core';
import { NgIf, NgForOf, AsyncPipe, CommonModule } from '@angular/common';
import { SHARE_BUTTONS, ShareService, SHARE_BUTTONS_CONFIG } from '@ngx-share/core';
import { ShareButton, ShareButtonModule } from '@ngx-share/button';
import { __assign } from 'tslib';
import { BehaviorSubject, Subscription } from 'rxjs';
import { map } from 'rxjs/operators';
import { FaIconComponent } from '@fortawesome/angular-fontawesome';

var ExpandButton = /** @class */ (function () {
    function ExpandButton(el) {
        this.toggle = new EventEmitter();
        el.nativeElement.style.setProperty('--button-color', '#FF6651');
    }
    ExpandButton.ɵfac = function ExpandButton_Factory(t) { return new (t || ExpandButton)(ɵɵdirectiveInject(ElementRef)); };
    ExpandButton.ɵcmp = ɵɵdefineComponent({ type: ExpandButton, selectors: [["expand-button"]], inputs: { moreIcon: "moreIcon", lessIcon: "lessIcon", expanded: "expanded", size: "size" }, outputs: { toggle: "toggle" }, decls: 5, vars: 3, consts: [[1, "sb-wrapper", "sb-expand", "sb-show-icon", 3, "click"], [1, "sb-inner"], [1, "sb-content"], [1, "sb-icon"], [3, "icon"]], template: function ExpandButton_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "button", 0);
            ɵɵlistener("click", function ExpandButton_Template_button_click_0_listener() { return ctx.toggle.emit(!ctx.expanded); });
            ɵɵelementStart(1, "div", 1);
            ɵɵelementStart(2, "div", 2);
            ɵɵelementStart(3, "div", 3);
            ɵɵelement(4, "fa-icon", 4);
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵstyleProp("font-size", ctx.size, "px");
            ɵɵadvance(4);
            ɵɵproperty("icon", ctx.expanded ? ctx.lessIcon : ctx.moreIcon);
        } }, directives: [FaIconComponent], encapsulation: 2, changeDetection: 0 });
    return ExpandButton;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ExpandButton, [{
        type: Component,
        args: [{
                selector: 'expand-button',
                changeDetection: ChangeDetectionStrategy.OnPush,
                template: "\n    <button class=\"sb-wrapper sb-expand sb-show-icon\"\n            [style.fontSize.px]=\"size\"\n            (click)=\"toggle.emit(!expanded)\">\n\n      <div class=\"sb-inner\">\n        <div class=\"sb-content\">\n          <div class=\"sb-icon\">\n            <fa-icon [icon]=\"expanded ? lessIcon : moreIcon\"></fa-icon>\n          </div>\n        </div>\n      </div>\n    </button>\n  "
            }]
    }], function () { return [{ type: ElementRef }]; }, { moreIcon: [{
            type: Input
        }], lessIcon: [{
            type: Input
        }], expanded: [{
            type: Input
        }], size: [{
            type: Input
        }], toggle: [{
            type: Output
        }] }); })();

function ShareButtons_div_0_share_button_1_Template(rf, ctx) { if (rf & 1) {
    var _r18 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "share-button", 3);
    ɵɵlistener("opened", function ShareButtons_div_0_share_button_1_Template_share_button_opened_0_listener($event) { ɵɵrestoreView(_r18); var ctx_r17 = ɵɵnextContext(2); return ctx_r17.opened.emit($event); })("closed", function ShareButtons_div_0_share_button_1_Template_share_button_closed_0_listener($event) { ɵɵrestoreView(_r18); var ctx_r19 = ɵɵnextContext(2); return ctx_r19.closed.emit($event); })("count", function ShareButtons_div_0_share_button_1_Template_share_button_count_0_listener($event) { ɵɵrestoreView(_r18); var ctx_r20 = ɵɵnextContext(2); return ctx_r20.count.emit($event); });
    ɵɵelementEnd();
} if (rf & 2) {
    var button_r16 = ctx.$implicit;
    var ctx_r14 = ɵɵnextContext(2);
    ɵɵproperty("button", button_r16)("theme", ctx_r14.theme)("url", ctx_r14.url)("title", ctx_r14.title)("description", ctx_r14.description)("image", ctx_r14.image)("tags", ctx_r14.tags)("autoSetMeta", ctx_r14.autoSetMeta)("showCount", ctx_r14.showCount)("showIcon", ctx_r14.showIcon)("showText", ctx_r14.showText)("size", ctx_r14.size);
} }
function ShareButtons_div_0_expand_button_3_Template(rf, ctx) { if (rf & 1) {
    var _r22 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "expand-button", 4);
    ɵɵlistener("toggle", function ShareButtons_div_0_expand_button_3_Template_expand_button_toggle_0_listener($event) { ɵɵrestoreView(_r22); var ctx_r21 = ɵɵnextContext(2); return ctx_r21.updateState({ expanded: $event }); });
    ɵɵelementEnd();
} if (rf & 2) {
    var state_r13 = ɵɵnextContext().$implicit;
    var ctx_r15 = ɵɵnextContext();
    ɵɵproperty("expanded", state_r13.expanded)("moreIcon", state_r13.moreIcon)("lessIcon", state_r13.lessIcon)("size", (1 + ctx_r15.size / 20) * 14);
} }
function ShareButtons_div_0_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div");
    ɵɵtemplate(1, ShareButtons_div_0_share_button_1_Template, 1, 12, "share-button", 1);
    ɵɵelementStart(2, "div");
    ɵɵtemplate(3, ShareButtons_div_0_expand_button_3_Template, 1, 4, "expand-button", 2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var state_r13 = ctx.$implicit;
    var ctx_r12 = ɵɵnextContext();
    ɵɵclassMapInterpolate1("sb-group sb-", ctx_r12.theme, "");
    ɵɵadvance(1);
    ɵɵproperty("ngForOf", state_r13.selectedButtons);
    ɵɵadvance(1);
    ɵɵclassMapInterpolate1("sb-button sb-", ctx_r12.theme, "");
    ɵɵadvance(1);
    ɵɵproperty("ngIf", state_r13.shownCount < state_r13.userButtons.length);
} }
var ShareButtons = /** @class */ (function () {
    function ShareButtons(_share) {
        this._share = _share;
        this._state$ = new BehaviorSubject({
            includedButtons: [],
            excludedButtons: [],
            userButtons: [],
            selectedButtons: [],
            expanded: true,
            shownCount: Object.keys(SHARE_BUTTONS).length
        });
        this._configSub$ = Subscription.EMPTY;
        this.theme = this._share.config.theme;
        /** Show buttons icons */
        this.showIcon = true;
        /** Show buttons text */
        this.showText = false;
        /** Show sharing count */
        this.showCount = false;
        /** Buttons size */
        this.size = 0;
        /** Share count event */
        this.count = new EventEmitter();
        /** Share dialog opened event */
        this.opened = new EventEmitter();
        /** Share dialog closed event */
        this.closed = new EventEmitter();
    }
    Object.defineProperty(ShareButtons.prototype, "includedButtons", {
        set: function (includedButtons) {
            this.updateState({ includedButtons: includedButtons });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShareButtons.prototype, "excludedButtons", {
        set: function (excludedButtons) {
            this.updateState({ excludedButtons: excludedButtons });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShareButtons.prototype, "shownButtons", {
        set: function (shownCount) {
            this.updateState({ shownCount: shownCount });
        },
        enumerable: true,
        configurable: true
    });
    ShareButtons.prototype.ngOnInit = function () {
        var _this = this;
        this.state$ = this._state$.pipe(map(function (state) {
            // Use component include buttons, otherwise fallback to global include buttons
            var includedButtons = state.includedButtons.length ? state.includedButtons : state.userButtons;
            var userButtons = includedButtons.filter(function (btn) { return state.excludedButtons.indexOf(btn) < 0; });
            var selectedButtons = userButtons.slice(0, state.expanded ? userButtons.length : state.shownCount);
            return {
                userButtons: userButtons,
                selectedButtons: selectedButtons,
                expanded: state.expanded,
                shownCount: state.shownCount,
                moreIcon: state.moreIcon,
                lessIcon: state.lessIcon
            };
        }));
        // Subscribe to share buttons config changes, This updates the component whenever a new button is added
        this._configSub$ = this._share.config$.subscribe(function (config) {
            // Use global include buttons, otherwise fallback to all buttons
            var includedButtons = config.include.length ? config.include : Object.keys(SHARE_BUTTONS);
            var userButtons = includedButtons.filter(function (btn) { return config.exclude.indexOf(btn) < 0; });
            _this.updateState({
                userButtons: userButtons,
                expanded: false,
                moreIcon: config.moreButtonIcon,
                lessIcon: config.lessButtonIcon
            });
        });
    };
    ShareButtons.prototype.ngOnDestroy = function () {
        this._configSub$.unsubscribe();
        this._state$.complete();
    };
    ShareButtons.prototype.updateState = function (state) {
        this._state$.next(__assign(__assign({}, this._state$.value), state));
    };
    ShareButtons.ɵfac = function ShareButtons_Factory(t) { return new (t || ShareButtons)(ɵɵdirectiveInject(ShareService)); };
    ShareButtons.ɵcmp = ɵɵdefineComponent({ type: ShareButtons, selectors: [["share-buttons"]], inputs: { theme: "theme", includedButtons: ["include", "includedButtons"], excludedButtons: ["exclude", "excludedButtons"], shownButtons: ["show", "shownButtons"], url: "url", title: "title", description: "description", image: "image", tags: "tags", autoSetMeta: "autoSetMeta", showIcon: "showIcon", showText: "showText", showCount: "showCount", size: "size" }, outputs: { count: "count", opened: "opened", closed: "closed" }, decls: 2, vars: 3, consts: [[3, "class", 4, "ngIf"], [3, "button", "theme", "url", "title", "description", "image", "tags", "autoSetMeta", "showCount", "showIcon", "showText", "size", "opened", "closed", "count", 4, "ngFor", "ngForOf"], [3, "expanded", "moreIcon", "lessIcon", "size", "toggle", 4, "ngIf"], [3, "button", "theme", "url", "title", "description", "image", "tags", "autoSetMeta", "showCount", "showIcon", "showText", "size", "opened", "closed", "count"], [3, "expanded", "moreIcon", "lessIcon", "size", "toggle"]], template: function ShareButtons_Template(rf, ctx) { if (rf & 1) {
            ɵɵtemplate(0, ShareButtons_div_0_Template, 4, 8, "div", 0);
            ɵɵpipe(1, "async");
        } if (rf & 2) {
            ɵɵproperty("ngIf", ɵɵpipeBind1(1, 1, ctx.state$));
        } }, directives: [NgIf, NgForOf, ShareButton, ExpandButton], pipes: [AsyncPipe], styles: ["[_nghost-%COMP%]{display:inherit}"], changeDetection: 0 });
    return ShareButtons;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ShareButtons, [{
        type: Component,
        args: [{
                selector: 'share-buttons',
                templateUrl: './share-buttons.html',
                styleUrls: ['./share-buttons.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: ShareService }]; }, { theme: [{
            type: Input
        }], includedButtons: [{
            type: Input,
            args: ['include']
        }], excludedButtons: [{
            type: Input,
            args: ['exclude']
        }], shownButtons: [{
            type: Input,
            args: ['show']
        }], url: [{
            type: Input
        }], title: [{
            type: Input
        }], description: [{
            type: Input
        }], image: [{
            type: Input
        }], tags: [{
            type: Input
        }], autoSetMeta: [{
            type: Input
        }], showIcon: [{
            type: Input
        }], showText: [{
            type: Input
        }], showCount: [{
            type: Input
        }], size: [{
            type: Input
        }], count: [{
            type: Output
        }], opened: [{
            type: Output
        }], closed: [{
            type: Output
        }] }); })();

var ShareButtonsModule = /** @class */ (function () {
    function ShareButtonsModule() {
    }
    ShareButtonsModule.withConfig = function (config) {
        return {
            ngModule: ShareButtonsModule,
            providers: [{ provide: SHARE_BUTTONS_CONFIG, useValue: config }]
        };
    };
    ShareButtonsModule.ɵmod = ɵɵdefineNgModule({ type: ShareButtonsModule });
    ShareButtonsModule.ɵinj = ɵɵdefineInjector({ factory: function ShareButtonsModule_Factory(t) { return new (t || ShareButtonsModule)(); }, imports: [[
                ShareButtonModule,
                CommonModule
            ],
            ShareButtonModule] });
    return ShareButtonsModule;
}());
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(ShareButtonsModule, { declarations: [ShareButtons,
        ExpandButton], imports: [ShareButtonModule,
        CommonModule], exports: [ShareButtonModule,
        ShareButtons] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(ShareButtonsModule, [{
        type: NgModule,
        args: [{
                declarations: [
                    ShareButtons,
                    ExpandButton
                ],
                imports: [
                    ShareButtonModule,
                    CommonModule
                ],
                exports: [
                    ShareButtonModule,
                    ShareButtons
                ]
            }]
    }], null, null); })();

/**
 * Generated bundle index. Do not edit.
 */

export { ShareButtons, ShareButtonsModule };
//# sourceMappingURL=ngx-share-buttons.js.map
